--Colorize proclaim
function vexalarm_colorize_class(msg, caster, class)
	local returnvalue = msg
	if class == nil or class == "" then
		if caster then	class = select(2, UnitClass(caster))
		else			class = select(2, UnitClass(msg)) end
	end
	if class == "" or class == nil then class = "NONE" end
	
	returnvalue="|CFF"..vexalarm_parameters["colors"]["cc"][class]..msg.."|r"

	return returnvalue
end

function vexalarm_colorize_status(statustext, status)
	local returnvalue = ""
	if status then returnvalue="|CFF"..vexalarm_parameters["colors"]["active"]["HEX"]..""..statustext.."|r"
	else	 returnvalue="|CFF"..vexalarm_parameters["colors"]["inactive"]["HEX"]..statustext.."|r" end
	return returnvalue
end

function vexalarm_colorize_specific(msg, sub)
	local color = ""
	if 		sub == 1 then color = vexalarm_parameters["colors"]["caster_sc"]["HEX"]
	elseif 	sub == 2 then color = vexalarm_parameters["colors"]["target_sc"]["HEX"]
	else 				  color = vexalarm_parameters["colors"]["spell_sc"]["HEX"] end
	return "|CFF"..color..msg.."|r"
end


--Proclaim functions
function vexalarm_spellcheck(auraID, player, eventchar)
	local returnvalue = ""
	playerrole = vexalarm_getplayerrole(player)
	auratocheck=""..auraID

	--overflow check - check data
	local currenttime = time()
	if auratocheck==vexalarm_last_spell_id and vexalarm.last_spell_timestamp+1>=currenttime then
		if 		eventchar == "SPELL_CAST_SUCCESS" and vexalarm.last_spell_event == "SPELL_CAST_SUCCESS" then returnvalue = "dejavue"
		elseif 	eventchar == "SPELL_CAST_SUCCESS" and vexalarm.last_spell_event == "SPELL_AURA_APPLIED" then returnvalue = "dejavue"
		elseif 	eventchar == "SPELL_AURA_APPLIED" and vexalarm.last_spell_event == "SPELL_CAST_SUCCESS" then returnvalue = "dejavue"
		elseif 	eventchar == "SPELL_AURA_APPLIED" and vexalarm.last_spell_event == "SPELL_AURA_APPLIED" then returnvalue = "dejavue"
		elseif 	eventchar == "SPELL_AURA_REMOVED" and vexalarm.last_spell_event == "SPELL_AURA_REMOVED" then returnvalue = "dejavue"
		end
	end
	
	if eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_AURA_REMOVED" then
		--check in selfbuffs
		if returnvalue == "" then
			for i=1,#vexalarm_selfbuffs do
				if(auratocheck == vexalarm_selfbuffs[i][1] and vexalarm_selfbuffs[i][playerrole+1]) then	returnvalue="selfbuff" end
			end
		end
	
		--check in buffs
		if returnvalue == "" then
			for i=1,#vexalarm_buffs do 
				if(auratocheck == vexalarm_buffs[i][1] and vexalarm_buffs[i][playerrole+1]) then returnvalue="buff" end
			end
		end
	
		--check in grpbuffs
		if returnvalue == "" then
			for i=1,#vexalarm_grpbuffs do 
				if(auratocheck == vexalarm_grpbuffs[i][1] and vexalarm_grpbuffs[i][playerrole+1]) then returnvalue="grpbuff" end
			end
		end
	
	elseif eventchar == "SPELL_CAST_SUCCESS" then
		--check in instants
		if returnvalue == "" then
			for i=1,#vexalarm_instants do 
				if(auratocheck == vexalarm_instants[i][1] and vexalarm_instants[i][playerrole+1]) then returnvalue="instant" end
			end
		end
	
		--check in instantsself
		if returnvalue == "" then
			for i=1,#vexalarm_instantsself do 
				if(auratocheck == vexalarm_instantsself[i][1] and vexalarm_instantsself[i][playerrole+1]) then returnvalue="instantself" end
			end
		end
	end
	--overflow check - update data
	if returnvalue ~= "" and returnvalue ~= "dejavue" then
		vexalarm.last_spell_id = auratocheck
		vexalarm.last_spell_timestamp = currenttime
		vexalarm.last_spell_event = eventchar
	end
	return returnvalue
end

function vexalarm_check_fulltext()
	local framedata
	local currenttime = time()
	local rank = {0}
	if #vexalarm.proclaim_timestamps~= 0 then
		for i=1, #vexalarm.proclaim_texts do
			if vexalarm.proclaim_timestamps[i] ~= nil then
				framedata = vexalarm.proclaim_texts[i]
				
				if vexalarm.proclaim_timestamps[i]+vexalarm_parameters["timedata"]["show"]+vexalarm_parameters["timedata"]["vanish"]+0.5 <= currenttime then
					framedata[1]:Hide()
					table.remove(vexalarm.proclaim_timestamps, i)
					table.remove(vexalarm.proclaim_texts, i)
					if not(vexalarm_parameters["frame"]["allowscrolling"]) then
						local place=framedata[4]
						vexalarm.printouts[place]=false
					end
				elseif vexalarm.proclaim_timestamps[i]+vexalarm_parameters["timedata"]["show"] < currenttime and vexalarm.proclaim_timestamps[i]+vexalarm_parameters["timedata"]["show"]+vexalarm_parameters["timedata"]["vanish"]+0.5 > currenttime and vexalarm_parameters["timedata"]["allowvanish"] and not(framedata[3]) then
					if vexalarm_frame_allow_scrolling then
						framedata[2]:SetPoint("TOPLEFT", vexalarm_frame_bg, "TOPLEFT" ,
								vexalarm_parameters["frame"]["position"]["alarm"]["x"],
								(-vexalarm_parameters["frame"]["position"]["alarm"]["spacing"]*(#rank+1))+vexalarm_parameters["frame"]["position"]["alarm"]["y"])
					else
						if framedata[4]==nil then
							local place = 1
							for i=1,#vexalarm.printouts+1 do
								if place == 1 and not(vexalarm.printouts[i]) then place = i end
							end
							vexalarm.printouts[place] = true
							framedata[4] = place
							framedata[2]:SetPoint("TOPLEFT", vexalarm_frame_bg, "TOPLEFT",
									vexalarm_parameters["frame"]["position"]["alarm"]["x"],
									(-vexalarm_parameters["frame"]["position"]["alarm"]["spacing"]*place)+vexalarm_parameters["frame"]["position"]["alarm"]["y"])
						end
					end
					framedata[3] = true
					rank[#rank+1] = i
				else
					if vexalarm_parameters["frame"]["allowscrolling"] then
						framedata[2]:SetPoint("TOPLEFT", vexalarm_frame_bg, "TOPLEFT",
								vexalarm_parameters["frame"]["position"]["alarm"]["x"],
								(-vexalarm_parameters["frame"]["position"]["alarm"]["spacing"]*(#rank+1))+vexalarm_parameters["frame"]["position"]["alarm"]["y"])
					else
						if framedata[4]==nil then
							local place = 1
							for i=1,#vexalarm.printouts+1 do
								if place == 1 and not(vexalarm.printouts[i]) then place = i end
							end
							vexalarm.printouts[place] = true
							framedata[4] = place
							framedata[2]:SetPoint("TOPLEFT", vexalarm_frame_bg, "TOPLEFT",
								vexalarm_parameters["frame"]["position"]["alarm"]["x"],
								(-vexalarm_parameters["frame"]["position"]["alarm"]["spacing"]*place)+vexalarm_parameters["frame"]["position"]["alarm"]["y"])
						end
					end
					framedata[1]:Show()
					rank[#rank+1] = i
				end
			end
		end
	end
	
	if vexalarm_parameters["frame"]["allowscrolling"] then
		if #rank>vexalarm_parameters["frame"]["maxevents"]+1 then
			for i=1, #rank-vexalarm_parameters["frame"]["maxevents"]-1 do
				framedata = vexalarm.proclaim_texts[rank[i+1]]
				framedata[1]:Hide()
				table.remove(vexalarm.proclaim_timestamps, rank[i+1])
				table.remove(vexalarm.proclaim_texts, rank[i+1])
			end
			vexalarm_check_fulltext()
		end
	end
end

function vexalarm_generate_fulltext(msg, status)
	local currenttime = time()
	local insert = {}
	local newmsgframe = CreateFrame("Frame", "vexalarm_proclaim_textframe", vexalarm_frame_bg)
	newmsgframe.name = "vexalarm_proclaim_textframe"
	newmsgframe.parent = "vexalarm_frame_bg"
		
	local newmsg = newmsgframe:CreateFontString("newmsgframe", "ARTWORK", "GameFontNormal")
	newmsg:SetPoint("TOPLEFT", vexalarm_frame_bg, "TOPLEFT" , 20, -3000)
	if status then 	newmsg:SetTextColor(vexalarm_parameters["frame"]["text"]["color"]["active"]["r"],
										vexalarm_parameters["frame"]["text"]["color"]["active"]["g"],
										vexalarm_parameters["frame"]["text"]["color"]["active"]["b"],
										vexalarm_parameters["frame"]["text"]["color"]["active"]["a"])
	else 			newmsg:SetTextColor(vexalarm_parameters["frame"]["text"]["color"]["inactive"]["r"],
										vexalarm_parameters["frame"]["text"]["color"]["inactive"]["g"],
										vexalarm_parameters["frame"]["text"]["color"]["inactive"]["b"],
										vexalarm_parameters["frame"]["text"]["color"]["inactive"]["a"])
	end
	newmsg:SetFont(vexalarm.LSM:Fetch("font", vexalarm_parameters["frame"]["text"]["font"]),
				vexalarm_parameters["frame"]["text"]["size"])	
	newmsg:SetJustifyH(vexalarm_parameters["frame"]["text"]["align"])
	newmsg:SetWidth(vexalarm_parameters["frame"]["size"]["width"]-vexalarm_parameters["frame"]["position"]["alarm"]["x"])
	newmsg:SetText(msg)	
	newmsgframe:Hide()
	newmsgframe_anigrp = newmsgframe:CreateAnimationGroup("newmsgframe_anigrp")
	newmsgframe_anigrp:SetLooping("NONE")
	newmsgframe_ani = newmsgframe_anigrp:CreateAnimation("Alpha")
	newmsgframe_ani:SetStartDelay(vexalarm_parameters["timedata"]["show"])
	newmsgframe_ani:SetEndDelay(5) -- Within the 5s the frame will hopefully be hidden and deleted, if not the scripthandler will delete it by calling vexalarm_check_fulltext()
	newmsgframe_anigrp:SetScript("OnFinished", function () vexalarm_check_fulltext() end)
	newmsgframe_ani:SetOrder(1)
	newmsgframe_ani:SetSmoothing("IN")
	if vexalarm_parameters["timedata"]["allowvanish"] then
		newmsgframe_ani:SetDuration(vexalarm_parameters["timedata"]["vanish"])
		newmsgframe_ani:SetChange(-1)
	else
		newmsgframe_ani:SetDuration(0)
		newmsgframe_ani:SetChange(1)
	end
	newmsgframe_anigrp:Play()
	
	insert[1] = newmsgframe
	insert[2] = newmsg
	insert[3] = false
	insert[5] = newmsgframe_anigrp
		
	table.insert(vexalarm.proclaim_timestamps, #vexalarm.proclaim_timestamps+1, currenttime)
	table.insert(vexalarm.proclaim_texts, #vexalarm.proclaim_texts+1, insert)
end

function vexalarm_generate_singlealarm(alarmtype, spell, caster, target, status)
	local customalarm = ""
	--load custom alarm text
	if 		alarmtype == "buff" 	and status 		then customalarm = vexalarm_parameters["msgs"]["buff"]["active"]
	elseif 	alarmtype == "buff" 	and not(status) then customalarm = vexalarm_parameters["msgs"]["buff"]["inactive"]
	elseif 	alarmtype == "selfbuff"	and status  	then customalarm = vexalarm_parameters["msgs"]["selfbuff"]["active"]
	elseif 	alarmtype == "selfbuff"	and not(status) then customalarm = vexalarm_parameters["msgs"]["selfbuff"]["inactive"]
	elseif 	alarmtype == "grpbuff"	and status 		then customalarm = vexalarm_parameters["msgs"]["grpbuff"]["active"]
	elseif 	alarmtype == "grpbuff"	and not(status) then customalarm = vexalarm_parameters["msgs"]["grpbuff"]["inactive"]
	elseif 	alarmtype == "instant" 					then customalarm = vexalarm_parameters["msgs"]["instant"]
	elseif 	alarmtype == "instantself" 				then customalarm = vexalarm_parameters["msgs"]["instantself"]
	end
	
	--load custom status msg
	if status then statustext=vexalarm_parameters["msgs"]["status"]["active"]
	else statustext=vexalarm_parameters["msgs"]["status"]["inactive"] end
	-- change [spell]
	if spell ~= nil then
		customalarm = string.gsub(customalarm, "{spell}", spell)
		customalarm = string.gsub(customalarm, "{spell_sc}", vexalarm_colorize_specific(spell, 3))
		customalarm = string.gsub(customalarm, "{spell_cc}", vexalarm_colorize_class(spell, caster))
	end
	
	-- change [caster]
	if caster ~= nil then
		customalarm = string.gsub(customalarm, "{caster}", caster)
		customalarm = string.gsub(customalarm, "{caster_sc}", vexalarm_colorize_specific(caster, 1))
		customalarm = string.gsub(customalarm, "{caster_cc}", vexalarm_colorize_class(caster))
	end
	
	-- change [target]
	if target ~= nil then
		customalarm = string.gsub(customalarm, "{target}", target)
		customalarm = string.gsub(customalarm, "{target_sc}", vexalarm_colorize_specific(target, 2))
		customalarm = string.gsub(customalarm, "{target_cc}", vexalarm_colorize_class(target))
	end
	
	-- change [statustext]
	if statustext ~= nil then
		customalarm = string.gsub(customalarm, "{status}", statustext)
		customalarm = string.gsub(customalarm, "{status_sc}", vexalarm_colorize_status(statustext, status))
		customalarm = string.gsub(customalarm, "{status_cc}", vexalarm_colorize_status(statustext, status))
	end
	return customalarm
end

function vexalarm_getplayerrole(player)
	local returnvalue = 4
	if player ~= nil then
		local role = UnitGroupRolesAssigned(player);
		
		if role == "DAMAGER" then returnvalue = 3
		elseif role == "HEALER" then returnvalue = 2
		elseif role == "TANK" then returnvalue = 1
		else returnvalue = 4
		end
	end
	return returnvalue
end

function vexalarm_proclaim(alarmtype, spell, caster, target, status)
	msg = vexalarm_generate_singlealarm(alarmtype, spell, caster, target, status)
	if msg~="" then vexalarm_generate_fulltext(msg, status) end
	vexalarm_check_fulltext()
	if vexalarm_parameters["sounds"]["allow"] and msg~="" and vexalarm.show then
		if status then 	PlaySoundFile(vexalarm.LSM:Fetch("sound", vexalarm_parameters["sounds"]["active"]["file"]), vexalarm_parameters["sounds"]["active"]["channel"])
		else 			PlaySoundFile(vexalarm.LSM:Fetch("sound", vexalarm_parameters["sounds"]["inactive"]["file"]), vexalarm_parameters["sounds"]["inactive"]["channel"])
		end
	end
	
end

	
	