vexalarm_defaults = {
	["variableversion"] = 2,
	["enable"] = true,
	["showonlyinfight"] = false,
	["msgs"] = {
		["buff"] = {
			["active"] = "{spell_cc} casted by {caster_cc} on {target_cc}",
			["inactive"] = "{spell_cc} casted by {caster_cc} on {target_cc}",
			},
		["selfbuff"] = {
			["active"] = "{spell_cc} casted by {caster_cc}",
			["inactive"] = "{spell_cc} casted by {caster_cc}",
			},
		["grpbuff"] = {
			["active"] = "{spell_cc} on",
			["inactive"] = "{spell_cc} off",
			},
		["instant"] =  "{caster_cc} casted {spell_cc} on {target_cc}",
		["instantself"] =  "{caster_cc} casted {spell_cc}",
		["status"] = {
			["active"] = "active",
			["inactive"] = "inactive",
			},
		},
	["colors"] = {
		["active"] = 	{["HEX"] = "2cf22e",	["r"] = 0.176, 	["g"] = 0.968, 		["b"] = 0.184},
		["inactive"] = 	{["HEX"] = "bb3232",	["r"] = 0.749, 	["g"] = 0.204, 		["b"] = 0.204},
		["caster_sc"] = {["HEX"] = "fa56f8", 	["r"] = 1, 		["g"] = 0.345, 		["b"] = 0.992},
		["target_sc"] = {["HEX"] = "1815fa", 	["r"] = 0.098, 	["g"] = 0.0862, 	["b"] = 1},
		["spell_sc"] = 	{["HEX"] = "ce4c0c", 	["r"] = 0.8274, ["g"] = 0.3058, 	["b"] = 0.05098},
		["cc"] = {
			["DEATHKNIGHT"] = "C41F3B",
			["DRUID"] 		= "FF7D0A",
			["HUNTER"] 		= "ABD473",
			["MAGE"] 		= "69CCF0",
			["PALADIN"] 	= "F58CBA",
			["PRIEST"] 		= "FFFFFF",
			["ROGUE"] 		= "FFF569",
			["SHAMAN"] 		= "0070DE",
			["WARLOCK"] 	= "9482C9",
			["WARRIOR"] 	= "C79C6E",
			["MONK"] 		= "558A84",
			["NONE"] 		= "A1A1A1",
			},
		},
	["timedata"] = {
		["allowvanish"] = true,
		["show"] = 3,
		["vanish"] = 3,
		},
	["sounds"] = {
		["allow"] = true,
		["active"] = {["file"] = "01", ["channel"] = "Master"},
		["inactive"] = {["file"] = "27", ["channel"] = "Master"},
		},
	["frame"] = {
		["allowscrolling"] = true,
		["text"] = {
			["font"] = "Friz Quadrata TT",
			["align"] = "LEFT",
			["size"] = 14,
			["color"] = {
				["active"] = {["r"] = 1, ["g"] = 1, ["b"] = 1, ["a"] = 1},
				["inactive"] = {["r"] = 1, ["g"] = 0, ["b"] = 0, ["a"] = 1},
				},			
			},
		["maxevents"] = 5,
		["position"] = {
			["alarm"] = {["x"] = 20, ["y"] = 0, ["spacing"] = 20,},
			["bg"] = {["x"] = 0, ["y"] = 0, ["anchor"] = "CENTER"},
			},
		["size"] = {["width"] = 500, ["height"] = 200},
		["bg"] = {
			["texture"] = "Solid",
			["color"] = {["r"] = 0, ["g"] = 0, ["b"] = 0, ["a"] = 0.25},
			},
		["border"] = {
			["texture"] = "None",
			["size"] = 1,
			["color"] = {["r"] = 0, ["g"] = 0, ["b"] = 0, ["a"] = 1},
			},
		},
	}

function vexalarm_loaddefaults(force)
	local load_old = false
	if vexalarm_parameters == nil then load_old=true  end
	
	vexalarm_parameters =  vexalarm_check_tablecontent(vexalarm_defaults, vexalarm_parameters, force)
	
	if load_old then vexalarm_transfer_oldvariables() end
	
	if force then vexalarm_initialize(true) end
end

function vexalarm_check_tablecontent(defaults, saved, force)
	local temp = {}
	if force or type(saved) ~= "table" then temp=defaults
	else
		for key,val in pairs(defaults) do
			if type(val) == "table" then
				temp[key] = {}
				if saved[key] == nil then 	temp[key] = val
				else 						temp[key] = vexalarm_check_tablecontent(defaults[key], saved[key], force) end
			else
				if saved[key] == nil then 	temp[key] = val
				else 						temp[key] = saved[key] end
			end
		end
	end
	return temp
end

function vexalarm_transfer_oldvariables()
	local loaded_old_data = 0
	if vexalarm_proclaim_text_status_color ~= nil then
		if vexalarm_proclaim_text_status_color[1][1] ~=nil then vexalarm_parameters["colors"]["active"]["HEX"] = vexalarm_proclaim_text_status_color[1][1] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_text_status_color[1][2] ~=nil then vexalarm_parameters["colors"]["active"]["r"] = vexalarm_proclaim_text_status_color[1][2] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_text_status_color[1][3] ~=nil then vexalarm_parameters["colors"]["active"]["g"] = vexalarm_proclaim_text_status_color[1][3] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_text_status_color[1][4] ~=nil then vexalarm_parameters["colors"]["active"]["b"] = vexalarm_proclaim_text_status_color[1][4] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_text_status_color[2][1] ~=nil then vexalarm_parameters["colors"]["inactive"]["HEX"] = vexalarm_proclaim_text_status_color[2][1] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_text_status_color[2][2] ~=nil then vexalarm_parameters["colors"]["inactive"]["r"] = vexalarm_proclaim_text_status_color[2][2] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_text_status_color[2][3] ~=nil then vexalarm_parameters["colors"]["inactive"]["g"] = vexalarm_proclaim_text_status_color[2][3] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_text_status_color[2][4] ~=nil then vexalarm_parameters["colors"]["inactive"]["b"] = vexalarm_proclaim_text_status_color[2][4] loaded_old_data=loaded_old_data+1 end
	end
	if vexalarm_proclaim_constant_colors ~= nil then
		if vexalarm_proclaim_constant_colors[1][1] ~=nil then vexalarm_parameters["colors"]["caster_sc"]["HEX"] = vexalarm_proclaim_constant_colors[1][1] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_constant_colors[1][2] ~=nil then vexalarm_parameters["colors"]["caster_sc"]["r"] = vexalarm_proclaim_constant_colors[1][2] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_constant_colors[1][3] ~=nil then vexalarm_parameters["colors"]["caster_sc"]["g"] = vexalarm_proclaim_constant_colors[1][3] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_constant_colors[1][4] ~=nil then vexalarm_parameters["colors"]["caster_sc"]["b"] = vexalarm_proclaim_constant_colors[1][4] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_constant_colors[2][1] ~=nil then vexalarm_parameters["colors"]["target_sc"]["HEX"] = vexalarm_proclaim_constant_colors[2][1] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_constant_colors[2][2] ~=nil then vexalarm_parameters["colors"]["target_sc"]["r"] = vexalarm_proclaim_constant_colors[2][2] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_constant_colors[2][3] ~=nil then vexalarm_parameters["colors"]["target_sc"]["g"] = vexalarm_proclaim_constant_colors[2][3] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_constant_colors[2][4] ~=nil then vexalarm_parameters["colors"]["target_sc"]["b"] = vexalarm_proclaim_constant_colors[2][4] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_constant_colors[3][1] ~=nil then vexalarm_parameters["colors"]["spell_sc"]["HEX"] = vexalarm_proclaim_constant_colors[3][1] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_constant_colors[3][2] ~=nil then vexalarm_parameters["colors"]["spell_sc"]["r"] = vexalarm_proclaim_constant_colors[3][2] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_constant_colors[3][3] ~=nil then vexalarm_parameters["colors"]["spell_sc"]["g"] = vexalarm_proclaim_constant_colors[3][3] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_constant_colors[3][4] ~=nil then vexalarm_parameters["colors"]["spell_sc"]["b"] = vexalarm_proclaim_constant_colors[3][4] loaded_old_data=loaded_old_data+1 end
	end
	if vexalarm_proclaim_vanish ~=nil then vexalarm_parameters["timedata"]["allowvanish"] = vexalarm_proclaim_vanish end
	if vexalarm_times ~= nil then
		if vexalarm_times[1] ~=nil then vexalarm_parameters["timedata"]["show"] = vexalarm_times[1] loaded_old_data=loaded_old_data+1 end
		if vexalarm_times[2] ~=nil then vexalarm_parameters["timedata"]["vanish"] = vexalarm_times[2] loaded_old_data=loaded_old_data+1 end
	end
	if vexalarm_showonlyinfight ~=nil then vexalarm_parameters["showonlyinfight"] = vexalarm_showonlyinfight end
	if vexalarm_show ~=nil then vexalarm_parameters["enable"] = vexalarm_show end
	if vexalarm_sounds ~= nil then
		if vexalarm_sounds[1][1] ~=nil then vexalarm_parameters["sounds"]["active"]["file"] = vexalarm_sounds[1][1] loaded_old_data=loaded_old_data+1 end
		if vexalarm_sounds[1][2] ~=nil then vexalarm_parameters["sounds"]["active"]["channel"] = vexalarm_sounds[1][2] loaded_old_data=loaded_old_data+1 end
		if vexalarm_sounds[2][1] ~=nil then vexalarm_parameters["sounds"]["inactive"]["file"] = vexalarm_sounds[2][1] loaded_old_data=loaded_old_data+1 end
		if vexalarm_sounds[2][2] ~=nil then vexalarm_parameters["sounds"]["inactive"]["channel"] = vexalarm_sounds[2][2] loaded_old_data=loaded_old_data+1 end
	end
	if vexalarm_allow_sounds ~=nil then vexalarm_parameters["sounds"]["allow"] = vexalarm_allow_sounds loaded_old_data=loaded_old_data+1 end
	if vexalarm_proclaim_buff ~=nil then vexalarm_parameters["msgs"]["buff"]["active"] = vexalarm_proclaim_buff loaded_old_data=loaded_old_data+1 end
	if vexalarm_proclaim_buff2 ~=nil then vexalarm_parameters["msgs"]["buff"]["inactive"] =  vexalarm_proclaim_buff2 loaded_old_data=loaded_old_data+1 end
	if vexalarm_proclaim_selfbuff ~=nil then vexalarm_parameters["msgs"]["selfbuff"]["active"] = vexalarm_proclaim_selfbuff loaded_old_data=loaded_old_data+1 end
	if vexalarm_proclaim_selfbuff2 ~=nil then vexalarm_parameters["msgs"]["selfbuff"]["inactive"] = vexalarm_proclaim_selfbuff2 loaded_old_data=loaded_old_data+1 end
	if vexalarm_proclaim_grpbuff ~=nil then vexalarm_parameters["msgs"]["grpbuff"]["active"] = vexalarm_proclaim_grpbuff loaded_old_data=loaded_old_data+1 end
	if vexalarm_proclaim_grpbuff2 ~=nil then vexalarm_parameters["msgs"]["grpbuff"]["inactive"] = vexalarm_proclaim_grpbuff2 loaded_old_data=loaded_old_data+1 end
	if vexalarm_proclaim_instant ~=nil then vexalarm_parameters["msgs"]["instant"] = vexalarm_proclaim_instant loaded_old_data=loaded_old_data+1 end
	if vexalarm_proclaim_instantself ~=nil then vexalarm_parameters["msgs"]["instantself"] = vexalarm_proclaim_instantself loaded_old_data=loaded_old_data+1 end
	if vexalarm_proclaim_text_status ~= nil then
		if vexalarm_proclaim_text_status[1] ~=nil then vexalarm_parameters["msgs"]["status"]["active"] = vexalarm_proclaim_text_status[1] loaded_old_data=loaded_old_data+1 end
		if vexalarm_proclaim_text_status[2] ~=nil then vexalarm_parameters["msgs"]["status"]["inactive"] = vexalarm_proclaim_text_status[2] loaded_old_data=loaded_old_data+1 end
	end
	if vexalarm_text_color ~= nil then
		if vexalarm_text_color[1][1] ~=nil then vexalarm_parameters["frame"]["text"]["color"]["active"]["r"] = vexalarm_text_color[1][1] loaded_old_data=loaded_old_data+1 end
		if vexalarm_text_color[1][2] ~=nil then vexalarm_parameters["frame"]["text"]["color"]["active"]["g"] = vexalarm_text_color[1][2] loaded_old_data=loaded_old_data+1 end
		if vexalarm_text_color[1][3] ~=nil then vexalarm_parameters["frame"]["text"]["color"]["active"]["b"] = vexalarm_text_color[1][3] loaded_old_data=loaded_old_data+1 end
		if vexalarm_text_color[2][1] ~=nil then vexalarm_parameters["frame"]["text"]["color"]["inactive"]["r"] = vexalarm_text_color[2][1] loaded_old_data=loaded_old_data+1 end
		if vexalarm_text_color[2][2] ~=nil then vexalarm_parameters["frame"]["text"]["color"]["inactive"]["g"] = vexalarm_text_color[2][2] loaded_old_data=loaded_old_data+1 end
		if vexalarm_text_color[2][3] ~=nil then vexalarm_parameters["frame"]["text"]["color"]["inactive"]["b"] = vexalarm_text_color[2][3] loaded_old_data=loaded_old_data+1 end
	end
	if vexalarm_frame_proclaim_xvalue ~=nil then vexalarm_parameters["frame"]["position"]["alarm"]["x"] = vexalarm_frame_proclaim_xvalue loaded_old_data=loaded_old_data+1 vexalarm_parameters["frame"]["position"]["bg"]["anchor"]="TOPLEFT" end
	if vexalarm_frame_proclaim_yvalue ~=nil then vexalarm_parameters["frame"]["position"]["alarm"]["y"] = vexalarm_frame_proclaim_yvalue loaded_old_data=loaded_old_data+1 end
	if vexalarm_frame_proclaim_spacing ~=nil then vexalarm_parameters["frame"]["position"]["alarm"]["spacing"] = vexalarm_frame_proclaim_spacing loaded_old_data=loaded_old_data+1 end
	if vexalarm_frame_xvalue ~=nil then vexalarm_parameters["frame"]["position"]["bg"]["x"] = vexalarm_frame_xvalue loaded_old_data=loaded_old_data+1 end
	if vexalarm_frame_yvalue ~=nil then vexalarm_parameters["frame"]["position"]["bg"]["y"] = vexalarm_frame_yvalue loaded_old_data=loaded_old_data+1 end
	if vexalarm_frame_allow_scrolling ~=nil then vexalarm_parameters["frame"]["allowscrolling"] = vexalarm_frame_allow_scrolling loaded_old_data=loaded_old_data+1 end
	if vexalarm_frame_font_align ~=nil then vexalarm_parameters["frame"]["text"]["align"] = vexalarm_frame_font_align loaded_old_data=loaded_old_data+1 end
	if vexalarm_frame_font ~=nil then vexalarm_parameters["frame"]["text"]["font"] = vexalarm_frame_font loaded_old_data=loaded_old_data+1 end
	if vexalarm_frame_fontsize ~=nil then vexalarm_parameters["frame"]["text"]["size"] = vexalarm_frame_fontsize loaded_old_data=loaded_old_data+1 end
	if vexalarm_max_events ~=nil then vexalarm_parameters["frame"]["maxevents"] = vexalarm_max_events loaded_old_data=loaded_old_data+1 end
	if vexalarm_backdrop_color ~= nil then
		if vexalarm_backdrop_color[1] ~=nil then vexalarm_parameters["frame"]["bg"]["color"]["r"] = vexalarm_backdrop_color[1] loaded_old_data=loaded_old_data+1 end
		if vexalarm_backdrop_color[2] ~=nil then vexalarm_parameters["frame"]["bg"]["color"]["g"] = vexalarm_backdrop_color[2] loaded_old_data=loaded_old_data+1 end
		if vexalarm_backdrop_color[3] ~=nil then vexalarm_parameters["frame"]["bg"]["color"]["b"] = vexalarm_backdrop_color[3] loaded_old_data=loaded_old_data+1 end
		if vexalarm_backdrop_color[4] ~=nil then vexalarm_parameters["frame"]["bg"]["color"]["a"] = vexalarm_backdrop_color[4] loaded_old_data=loaded_old_data+1 end
	end
	if vexalarm_texture_bg ~=nil then vexalarm_parameters["frame"]["bg"]["texture"] = vexalarm_texture_bg loaded_old_data=loaded_old_data+1 end
	if vexalarm_edge_texture ~=nil then vexalarm_parameters["frame"]["border"]["texture"] = vexalarm_edge_texture loaded_old_data=loaded_old_data+1 end
	if vexalarm_frame_width ~=nil then vexalarm_parameters["frame"]["size"]["width"] = vexalarm_frame_width loaded_old_data=loaded_old_data+1 end
	if vexalarm_frame_height ~=nil then vexalarm_parameters["frame"]["size"]["height"] = vexalarm_frame_height loaded_old_data=loaded_old_data+1 end
end

function vexalarm_print_parameters()
	print(" ")
	print("|CFFFF7D0AListing OUTPUT|r")
	debugs.print(vexalarm_parameters, 'vexalarm_parameters')
	print("|CFFFF7D0AEnd of listing|r")
	print(" ")
end

