function vexalarm.panel_msgcontent()
	return {
		type = "group",
		order= 1,
		args = {
			grpmsgsinfo = {
				name = "Parse Information Tags",
				order=1, type ="group", dialogInline = true,
				args = {
					header = {name = "You can use the following tags to parse information in the messages\n\nCastername:\n|CFFFF7D0A{caster}|r uncolored, |CFFFF7D0A{caster_sc}|r specific colored, |CFFFF7D0A{caster_cc}|r classcolored\n\ntargetname:\n|CFFFF7D0A{target}|r uncolored, |CFFFF7D0A{target_sc}|r specific colored, |CFFFF7D0A{target_cc}|r classcolored\n\nspellname:\n|CFFFF7D0A{spell}|r uncolored, |CFFFF7D0A{spell_sc}|r specific colred, |CFFFF7D0A{spell_cc}|r classcolored\n\nstatus:\n|CFFFF7D0A{status}|r uncolored, |CFFFF7D0A{status_c}|r specific colored",
						type = "description", order=1, fontSize="medium"},
					},
				},
			framemsgs1 = {name ="\n", type = "description", order=2},
		
			grpmsgsbuffs = {
				name = "Buffs with a single target",
				order=10, type ="group", dialogInline = true,
				args = {
					buff = {
						name = "active message",
						desc = "this message is shown when a buff becomes active",
						order=1, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_parameters["msgs"]["buff"]["active"]=val end,
						get = function() return vexalarm_parameters["msgs"]["buff"]["active"] end
						},
					buffdefault = {
						name = "set to defaults",
						desc = "set the message to the defaults",
						order=2, type = "execute",
						func = function(info,val) vexalarm_parameters["msgs"]["buff"]["active"]=vexalarm_defaults["msgs"]["buff"]["active"] end,
						},
					buff2 = {
						name = "inactive message",
						desc = "this message is shown when a buff becomes inactive",
						order=3, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_parameters["msgs"]["buff"]["inactive"]=val end,
						get = function() return vexalarm_parameters["msgs"]["buff"]["inactive"] end
						},
					buff2default = {
						name = "set to defaults",
						desc = "set the message to the defaults",
						order=4, type = "execute",
						func = function(info,val) vexalarm_parameters["msgs"]["buff"]["inactive"]=vexalarm_defaults["msgs"]["buff"]["inactive"] end,
						},
					},
				},
			framemsgs2 = {name ="\n", type = "description", order=11},
				
			grpmsgsselfbuffs = {
				name = "Buffs without a target (selfbuffs)",
				order=20, type ="group", dialogInline = true,
				args = {
					selfbuff = {
						name = "active message",
						desc = "this message is shown when a buff becomes active/inactive",
						order=1, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_parameters["msgs"]["selfbuff"]["active"]=val end,
						get = function() return vexalarm_parameters["msgs"]["selfbuff"]["active"] end
						},
					selfbuffdefault = {
						name = "set to defaults",
						desc = "set the message to the defaults",
						order=2, type = "execute",
						func = function(info,val) vexalarm_parameters["msgs"]["selfbuff"]["active"]=vexalarm_defaults["msgs"]["selfbuff"]["active"] end,
						},
					selfbuff2 = {
						name = "inactive message",
						desc = "this message is shown when a buff becomes active/inactive",
						order=3, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_parameters["msgs"]["selfbuff"]["inactive"]=val end,
						get = function() return vexalarm_parameters["msgs"]["selfbuff"]["inactive"] end
						},
					selfbuff2default = {
						name = "set to defaults",
						desc = "set the message to the defaults",
						order=4, type = "execute",
						func = function(info,val) vexalarm_parameters["msgs"]["selfbuff"]["inactive"]=vexalarm_defaults["msgs"]["selfbuff"]["inactive"] end,
						},
					},
				},
			framemsgs3 = {name ="\n", type = "description", order=21},
				
				
			grpmsgsgrpbuffs = {
				name = "Buffs without multiple targets (groupbuffs)",
				order=30, type ="group", dialogInline = true,
				args = {
					grpbuff = {
						name = "active message",
						desc = "this message is shown when a buff becomes active/inactive",
						order=1, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_parameters["msgs"]["grpbuff"]["active"]=val end,
						get = function() return vexalarm_parameters["msgs"]["grpbuff"]["active"] end
						},
					grpbuffdefault = {
						name = "set to defaults",
						desc = "set the message to the defaults",
						order=2, type = "execute",
						func = function(info,val) vexalarm_parameters["msgs"]["grpbuff"]["active"]=vexalarm_defaults["msgs"]["grpbuff"]["active"] end,
						},
					grpbuff2 = {
						name = "inactive message",
						desc = "this message is shown when a buff becomes active/inactive",
						order=3, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_parameters["msgs"]["grpbuff"]["inactive"]=val end,
						get = function() return vexalarm_parameters["msgs"]["grpbuff"]["inactive"] end
						},
					grpbuff2default = {
						name = "set to defaults",
						desc = "set the message to the defaults",
						order=4, type = "execute",
						func = function(info,val) vexalarm_parameters["msgs"]["grpbuff"]["inactive"]=vexalarm_defaults["msgs"]["grpbuff"]["inactive"] end,
						},
					},
				},
			framemsgs4 = {name ="\n", type = "description", order=31},
				
			grpmsgsinstants = {
				name = "Casts with a target",
				order=40, type ="group", dialogInline = true,
				args = {
					instant = {
						name = "Message",
						desc = "this message is shown when a spell becomes active/inactive",
						order=1, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_parameters["msgs"]["instant"]=val end,
						get = function() return vexalarm_parameters["msgs"]["instant"] end
						},
					instantdefault = {
						name = "set to defaults",
						desc = "set the message to the defaults",
						order=2, type = "execute",
						func = function(info,val) vexalarm_parameters["msgs"]["instant"]=vexalarm_defaults["msgs"]["instant"] end,
						},
					},
				},
			framemsgs5 = {name ="\n", type = "description", order=41},
				
			grpmsgsinstantsself = {
				name = "Casts without a target",
				order=50, type ="group", dialogInline = true,
				args = {
					instantself = {
						name = "Message",
						desc = "this message is shown when a spell becomes active/inactive",
						order=1, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_parameters["msgs"]["instantself"]=val end,
						get = function() return vexalarm_parameters["msgs"]["instantself"] end
						},
					instantselfdefault = {
						name = "set to defaults",
						desc = "set the message to the defaults",
						order=2, type = "execute",
						func = function(info,val) vexalarm_parameters["msgs"]["instantself"]=vexalarm_defaults["msgs"]["instantself"] end,
						},
					},
				},
			framemsgs6 = {name ="\n", type = "description", order=51},
			
			grpmsgsstatus = {
				name = "{status} messages",
				order=50, type ="group", dialogInline = true,
				args = {
					activeself = {
						name = "{status} active",
						desc = "this message is shown when a buff becomes active",
						order=1, type = "input", multiline = false,
						set = function(info,val) vexalarm_parameters["msgs"]["status"]["active"]=val end,
						get = function() return vexalarm_parameters["msgs"]["status"]["active"] end
						},
					activedefault = {
						name = "set to defaults",
						desc = "set the message to the defaults",
						order=2, type = "execute",
						func = function(info,val) vexalarm_parameters["msgs"]["status"]["active"]=vexalarm_defaults["msgs"]["status"]["active"] end,
						},
					statusspace = {name ="\n", type = "description", order=3},
						
					inactiveself = {
						name = "{status} inactive",
						desc = "this message is shown when a buff becomes inactive",
						order=4, type = "input", multiline = false,
						set = function(info,val) vexalarm_parameters["msgs"]["status"]["inactive"]=val end,
						get = function() return vexalarm_parameters["msgs"]["status"]["inactive"] end
						},
					inactivedefault = {
						name = "set to defaults",
						desc = "set the message to the defaults",
						order=5, type = "execute",
						func = function(info,val) vexalarm_parameters["msgs"]["status"]["inactive"]=vexalarm_defaults["msgs"]["status"]["inactive"] end,
						},
					},
				},
			}
		}
end